package org.jeecg.modules.sensor.controller;

import java.util.Arrays;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.modules.sensor.entity.BuSensorType;
import org.jeecg.modules.sensor.service.IBuSensorTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 传感器类型表
 * @Author: jeecg-boot
 * @Date:   2024-05-07
 * @Version: V1.0
 */
@Api(tags="传感器类型表")
@RestController
@RequestMapping("/sensor/buSensorType")
@Slf4j
public class BuSensorTypeController extends JeecgController<BuSensorType, IBuSensorTypeService> {
	@Autowired
	private IBuSensorTypeService buSensorTypeService;
	
	/**
	 * 分页列表查询
	 *
	 * @param buSensorType
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "传感器类型表-分页列表查询")
	@ApiOperation(value="传感器类型表-分页列表查询", notes="传感器类型表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<BuSensorType>> queryPageList(BuSensorType buSensorType,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {
		QueryWrapper<BuSensorType> queryWrapper = QueryGenerator.initQueryWrapper(buSensorType, req.getParameterMap());
		Page<BuSensorType> page = new Page<BuSensorType>(pageNo, pageSize);
		IPage<BuSensorType> pageList = buSensorTypeService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param buSensorType
	 * @return
	 */
	@AutoLog(value = "传感器类型表-添加")
	@ApiOperation(value="传感器类型表-添加", notes="传感器类型表-添加")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_sensor_type:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BuSensorType buSensorType) {
		buSensorTypeService.save(buSensorType);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param buSensorType
	 * @return
	 */
	@AutoLog(value = "传感器类型表-编辑")
	@ApiOperation(value="传感器类型表-编辑", notes="传感器类型表-编辑")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_sensor_type:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BuSensorType buSensorType) {
		buSensorTypeService.updateById(buSensorType);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "传感器类型表-通过id删除")
	@ApiOperation(value="传感器类型表-通过id删除", notes="传感器类型表-通过id删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_sensor_type:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		buSensorTypeService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "传感器类型表-批量删除")
	@ApiOperation(value="传感器类型表-批量删除", notes="传感器类型表-批量删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_sensor_type:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buSensorTypeService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "传感器类型表-通过id查询")
	@ApiOperation(value="传感器类型表-通过id查询", notes="传感器类型表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<BuSensorType> queryById(@RequestParam(name="id",required=true) String id) {
		BuSensorType buSensorType = buSensorTypeService.getById(id);
		if(buSensorType==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buSensorType);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buSensorType
    */
    //@RequiresPermissions("org.jeecg.modules.demo:bu_sensor_type:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuSensorType buSensorType) {
        return super.exportXls(request, buSensorType, BuSensorType.class, "传感器类型表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_sensor_type:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuSensorType.class);
    }

}
